/* (C) Copyright 1991 Andrew Plotkin. Permission is
 given to copy and use, as long as this copyright
 notice is retained. */

#include <stdio.h>
#include <X11/Xlib.h>
#include "spheral.h"
#include "patchlevel.h"

#define INITWINSIZEX (800)
#define INITWINSIZEY ((int)(800*ROOTHALF))

int monomode = 0;

extern double focallen;
extern void srandom();

extern void xinit(), loadpieces(), gameloop(),
redo_board_globals();
extern void initintro(), initloop();
extern void init_ballpmflags();

main(argc, argv)
int argc;
char *argv[];
{
    int ix;

    srandom(getpid());

/*    for (ix=1; ix<argc; ix++) {
	if (strcmp(argv[ix], "-m")) {
	    fprintf(stderr, "usage: spheral [ -m ]\n");
	    exit(-1);
	}
	else
	    monomode = 1;
    }*/

    monomode = 1; /* I'm terribly sorry; color just does not
     work for this game. */

    loadpieces(PIECEFILENAME);
    fieldx = 6;
    fieldz = 12;
    fieldoffx = -0.5 * (fieldx-1);
    fieldoffy = -0.5 * ROOTHALF * (fieldx-2);
    fieldoffz = -4.0-(double)fieldz;
    focallen = 1.0;
    dispx = INITWINSIZEX;
    dispy = INITWINSIZEY;
    redo_board_globals();
    xinit();
    init_ballpmflags();
    get_names();
    load_hscores(0);
    while (1) {
	initintro();
	introloop();
	initgame();
	gameloop();
	if (checkmod_scores()) {
	    load_hscores(1);
	}
    }
}
